//----------------------------------------------------------------------------

//Pulse generator PG-862
//   

//----------------------------------------------------------------------------

#include <Main.h>
#include <Commands.h>
#include <Port.h>
#include <Wake.h>
#include <Menu.h>
#include <Sound.h>

//------------------------------ : ----------------------------------

const __flash char Info[] = {"PG-862 V1.0\0"}; // 

//----------------------------- : ----------------------------------

static bool cnLock = 0; //   
static bool cnMute = 0; //      PC

//---------------------------  : -----------------------------

void Tx_Replay(char n, char err); //   

//----------------------    : -------------------------

void Tx_Replay(char n, char err)
{
  Tx_Nbt = n;                     // 
  Tx_Dat[0] = err;                // 
  Tx_Cmd = Command;               //
  Port_Tx();                      // 
  Command = CMD_NOP;              // 
}

//----------------------------  : ----------------------------

void Commands_Exe(void)
{
  char i;
  switch(Command)
  {
  case CMD_ERR: // 
    {
      Tx_Replay(1, ERR_TX);
      break;
    }
  case CMD_ECHO: // ""
    {
      for(i = 0; i < Rx_Nbt && i < FRAME; i++)
        Tx_Dat[i] = Rx_Dat[i];
      Tx_Replay(Rx_Nbt, Tx_Dat[0]);
      break;
    }
  case CMD_INFO: // ""
    {
      char ch = 1;
      for(i = 0; i < FRAME && ch; i++)
        ch = Tx_Dat[i] = Info[i];
      Tx_Replay(i, Tx_Dat[0]);
      break;
    }
  case CMD_SETMODE: //  
    {
      cnLock = Rx_Dat[0] & 0x01;
      cnMute = Rx_Dat[0] & 0x02;
      Menu_Lock(cnLock, cnMute);
      Tx_Replay(1, ERR_NO);
      break;
    }
  case CMD_GETMODE: //  
    {
      char d = 0;
      if(cnLock) d |= 0x01;
      if(cnMute) d |= 0x02;
      Tx_Dat[1] = d;
      Tx_Replay(2, ERR_NO);
      break;
    }
  case CMD_SETPAR: // 
    {
      char n = Rx_Dat[0];         // 
      char c = Rx_Dat[1];         // 
      long par = DWORD(Rx_Dat[5], Rx_Dat[4], Rx_Dat[3], Rx_Dat[2]);
      Menu_SetPar(n, c, par);     // 
      Tx_Replay(1, ERR_NO);
      break;
    }
  case CMD_GETPAR: // 
    {
      long par = Menu_GetPar(Rx_Dat[0], Rx_Dat[1]);
      Tx_Dat[1] = BYTE1(par);
      Tx_Dat[2] = BYTE2(par);
      Tx_Dat[3] = BYTE3(par);
      Tx_Dat[4] = BYTE4(par);
      Tx_Replay(5, ERR_NO);
      break;
    }
  case CMD_GETSELPAR: //  
    {
      char n = Menu_GetSelPar();  // 
      char c = Menu_GetSelChan(); // 
      long par = Menu_GetPar(n, c);
      Tx_Dat[1] = n;
      Tx_Dat[2] = c;
      Tx_Dat[3] = BYTE1(par);
      Tx_Dat[4] = BYTE2(par);
      Tx_Dat[5] = BYTE3(par);
      Tx_Dat[6] = BYTE4(par);
      Tx_Replay(7, ERR_NO);
      break;
    }
  }
}

//----------------------------------------------------------------------------
